﻿using System;
using System.Collections;
using System.Reflection;
using UnityEngine;

namespace Mod
{
    public class LimbRegrowthSyringe : SyringeBehaviour
    {
        public const string name = "​<b></b>" + "Limb Regrowth Syringe";
        public static void Load()
        {
            ModAPI.RegisterLiquid(LimbRegrowthSyringeSerum.ID, new LimbRegrowthSyringeSerum());

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"),

                    NameOverride = name,
                    DescriptionOverride = "Syringe that regrows limbs.",

                    CategoryOverride = ModAPI.FindCategory("Polars Bear"),
                    AfterSpawn = (Instance) => { Destroy(Instance.GetComponent<SyringeBehaviour>()); Instance.GetOrAddComponent<LimbRegrowthSyringe>(); }
                }
            );
            Mod.nailgun.SyringeNail(name, typeof(LimbRegrowthSyringe));


        }
        public override string GetLiquidID() => LimbRegrowthSyringeSerum.ID;
        public class LimbRegrowthSyringeSerum : libs.OneTimeBodyLiquid
        {
            public const string ID = "​<b></b>" + "Limb Regrowth Syringe";
            public LimbRegrowthSyringeSerum()
            {
                Color = new Color(1f, 1f, 1f);
            }
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                foreach (LimbBehaviour limby in limb.Person.Limbs)
                {
                    limby.gameObject.GetOrAddComponent<RegrowLimb>();
                }
            }
        }

        public class RegrowLimb : MonoBehaviour
        {
            Joint2D[] joints;
            LimbBehaviour limb;
            PersonBehaviour person;
            GameObject bodypartClone;
            void Start()
            {
                joints = GetComponents<HingeJoint2D>();
                limb = GetComponent<LimbBehaviour>();
                person = limb.Person;
                SpawnableAsset asset = ModAPI.FindSpawnable("Human");
                GameObject bodyClone = Instantiate(asset.Prefab, GameObject.Find("WORLD").transform);

                foreach (LimbBehaviour limby in bodyClone.GetComponentsInChildren<LimbBehaviour>())
                {
                    if (limby.gameObject.name == gameObject.name)
                    {
                        bodypartClone = limby.gameObject;
                        bodypartClone.SetActive(false);
                        bodypartClone = Instantiate(bodypartClone, GameObject.Find("WORLD").transform);
                    }
                }

                Destroy(bodyClone);
            }
            void Update()
            {
                /*foreach(HingeJoint2D joint in joints)
                {
                    ModAPI.Draw.Line(transform.position, transform.TransformPoint(joint.anchor));
                    ModAPI.Draw.Circle(transform.TransformPoint(joint.anchor), 0.05f);
                }*/
            }

            void OnJointBreak2D(Joint2D joint)
            {
                joint.connectedBody.GetComponent<LimbBehaviour>().Color = new Color(0f, 0f, 1f);


                Instantiate(gameObject,transform.parent);

                /*
                GameObject obj = Instantiate(bodypartClone, transform.parent);

                Debug.Log(obj);



                obj.transform.position = transform.position;
                obj.transform.rotation = transform.rotation;
                Debug.Log(obj);
                LimbBehaviour limby = obj.GetComponent<LimbBehaviour>();
                CirculationBehaviour circ = limby.CirculationBehaviour;
                limby.Color = new Color(0f, 1f, 0f);
                Debug.Log(joint.connectedBody);

                limby.GetComponent<HingeJoint2D>().connectedBody = joint.connectedBody;
                Debug.Log(person);
                Debug.Log(limby);
                        
                limby.Person = person;
                limby.ConnectedLimbs = limb.ConnectedLimbs;
                limby.SkinMaterialHandler.adjacentLimbs = limb.SkinMaterialHandler.adjacentLimbs;
                circ.PushesTo = limb.CirculationBehaviour.PushesTo;

                Debug.Log(5);
                Debug.Log(limby);
                limby.gameObject.SetActive(true);*/
                
                

            }

        }

    }
}

//Author: Polars Bear
