
using UnityEngine;
using System;
using System.Collections;
using System.Reflection;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Nailgun nailgun;

		public static void OnLoad()
		{
            nailgun = new Nailgun();
        }

		public static void Main()
		{
			bool found = false;
			foreach (Category cat in CatalogBehaviour.Main.Catalog.Categories)
			{
				if (cat.name == "Polars Bear")
				{
					found = true;
				}
			}
			if (!found)
			{
				CategoryBuilder.Create("Polars Bear", "All of Polars Bear's creations", ModAPI.LoadSprite("sprites/bear.png"));
			}
			
			if (nailgun == null)
            {
				nailgun = new Nailgun();
            }

			nailgun.NailgunConstruct();
            AutoLoad.LoadScripts();
			
		}
	}
}